<!-- =========================================================================================
File Name: RegisterJWT.vue
Description: Register Page for JWT
========================================================================================== -->

<template>
  <div class="clearfix">
    <vs-input
      v-validate="'required|min:3'"
      data-vv-validate-on="blur"
      label-placeholder="Name"
      name="displayName"
      placeholder="Tên người dùng"
      v-model="displayName"
      class="w-full"
    />
    <span class="text-danger text-sm">{{ errors.first("displayName") }}</span>

    <vs-input
      v-validate="'required|email'"
      data-vv-validate-on="blur"
      name="email"
      type="email"
      label-placeholder="Email"
      placeholder="Email"
      v-model="email"
      class="w-full mt-8"
    />
    <span class="text-danger text-sm">{{ errors.first("email") }}</span>

    <vs-input
      ref="password"
      type="password"
      data-vv-validate-on="blur"
      v-validate="'required|min:6|max:24'"
      name="password"
      label-placeholder="Password"
      placeholder="Mật khẩu"
      v-model="password"
      class="w-full mt-8"
    />
    <span class="text-danger text-sm">{{ errors.first("password") }}</span>

    <vs-input
      type="password"
      v-validate="'min:6|max:24|confirmed:password'"
      data-vv-validate-on="blur"
      data-vv-as="password"
      name="confirm_password"
      label-placeholder="Confimed Password"
      placeholder="Xác nhận lại mật khẩu"
      v-model="confirm_password"
      class="w-full mt-8"
    />
    <span class="text-danger text-sm">{{
      errors.first("confirm_password")
    }}</span>

    <vs-checkbox v-model="isTermsConditionAccepted" class="mt-6"
      >Tôi đồng ý các điều kiện và điều khoản.</vs-checkbox
    >
    <vs-button type="border" to="/pages/login" class="mt-6">
      <div class="inline-flex items-center">
        <feather-icon
          icon="ChevronsLeftIcon"
          svgClasses="h-4 w-4 mr-1"
        ></feather-icon
        ><span>Đăng nhập</span>
      </div>
    </vs-button>
    <vs-button
      class="float-right mt-6"
      @click="registerUserJWt"
      :disabled="!validateForm"
      >Đăng ký</vs-button
    >
  </div>
</template>

<script>
import { Validator } from "vee-validate";

/* <CUSTOM ERROR MESSAGE> */
const dict = {
  custom: {
    displayName: {
      required: "Vui lòng nhập tên người dùng của bạn",
      min: "Tên người dùng phải có ít nhất 3 ký tự"
    },
    email: {
      required: "Vui lòng nhập email của bạn",
      email: "Email phải là một email hợp lệ"
    },
    password: {
      required: "Vui lòng nhập mật khẩu của bạn",
      min: "Mật khẩu phải có ít nhất 6 ký tự",
      max: "Mật khẩu không được lớn hơn 24 ký tự"
    },
    confirm_password: {
      required: "Vui lòng nhập lại mật khẩu của bạn",
      min: "Mật khẩu phải có ít nhất 6 ký tự",
      max: "Mật khẩu không được lớn hơn 24 ký tự",
      confirmed: "Xác nhận mật khẩu không khớp"
    }
  }
};
Validator.localize("vi", dict); // register custom messages
/* </CUSTOM ERROR MESSAGE> */

export default {
  data() {
    return {
      displayName: "",
      email: "",
      password: "",
      confirm_password: "",
      isTermsConditionAccepted: true
    };
  },
  computed: {
    validateForm() {
      return (
        !this.errors.any() &&
        this.displayName != "" &&
        this.email != "" &&
        this.password != "" &&
        this.confirm_password != "" &&
        this.isTermsConditionAccepted === true
      );
    }
  },
  methods: {
    checkLogin() {
      // If user is already logged in notify
      if (this.$store.state.auth.isUserLoggedIn()) {
        this.$warning({
          message: "You are already logged in!",
          title: "Login Attempt"
        });
        return false;
      }
      return true;
    },

    async registerUserJWt() {
      // If form is not validated or user is already login return
      if (!this.validateForm || !this.checkLogin()) return;

      const payload = {
        userDetails: {
          displayName: this.displayName,
          email: this.email,
          password: this.password,
          confirmPassword: this.confirm_password
        },
        notify: this.$vs.notify
      };

      this.$globalBusyOn();

      try {
        await this.$store.dispatch("auth/registerUserJWT", payload);
      } catch (error) {
        this.$error({ message: error.message });
      } finally {
        this.$globalBusyOff();
      }
    }
  }
};
</script>
